/*
 * sigprocmask() -- Examines and changes blocked signals.
 *
 * Written by matusita@ics.es.osaka-u.ac.jp.
 * This code is based on the code of Berkeley DB Package.
 * You can get DB from <URL:ftp://ftp.cs.berkeley.edu/ucb/4bsd/db.*.tar.gz>
 * or whereever its mirror/copy. See db.1.85/PORT/include/compat.h.
 */

#include <stdio.h>
#include <signal.h>
#include "missing.h"

int
sigprocmask(int how, const sigset_t *set, sigset_t *oset)
{
	int mask;

	if (how == SIG_BLOCK) {
		mask = sigblock(0) | *set;
	}
	else if (how == SIG_UNBLOCK) {
		mask = sigblock(0) & ~(*set);
	}
	else if (how == SIG_SETMASK) {
		mask = *set;
	}
	else {
		mask = sigblock(0);
	}
	mask = sigsetmask(mask);
	if (oset != NULL) {
		*oset = mask;
	}

	return 0;
}
